%global httpddir       %{_datadir}/httpd
%global docroot        /var/www
%global suexec_caller  apache
%global mmn            20120211
%global mmnisa         %{mmn}%{__isa_name}%{__isa_bits}
%global vstring        %(source /etc/os-release; echo ${NAME})
%global mpm event

Summary:  Apache HTTP Server
Name:     httpd
Version:  2.4.57
Release:  9%{?dist}
License:  ASL 2.0
URL:      https://httpd.apache.org/
Source0:  https://www.apache.org/dist/httpd/httpd-%{version}.tar.bz2
Source3:  00-base.conf
Source4:  00-brotli.conf
Source5:  00-dav.conf
Source6:  00-lua.conf
Source7:  00-mpm.conf
Source8:  00-optional.conf
Source9:  00-proxy.conf
Source10: 00-proxyhtml.conf
Source11: 00-ssl.conf
Source12: 00-systemd.conf
Source13: 01-cgi.conf
Source14: 01-ldap.conf
Source15: 01-session.conf
Source16: 10-listen443.conf
Source17: apache-poweredby.png
Source18: config.layout
Source19: htcacheclean.service
Source20: htcacheclean.sysconf
Source21: httpd.conf
Source22: httpd.logrotate
Source23: httpd.service
Source24: httpd.socket
Source25: httpd.sysusers
Source26: httpd.tmpfiles
Source27: httpd@.service
Source28: httpd-init.service
Source29: httpd-ssl-pass-dialog
Source30: instance.conf
Source31: README.confd
Source32: README.confmod
Source33: ssl.conf
Source34: userdir.conf
Source35: welcome.conf
Source36: httpd-ssl-gencerts

Patch0001: httpd-2.4.48-r1842929+.patch
Patch0002: httpd-2.4.43-gettid.patch
Patch0004: httpd-2.4.43-r1861793+.patch
Patch0005: httpd-2.4.53-separate-systemd-fns.patch
Patch0006: httpd-2.4.43-enable-sslv3.patch
Patch0007: httpd-2.4.48-r1878890.patch
Patch0008: CVE-2023-31122-out-of-bound-Read.patch
Patch0009: CVE-2023-43622-fixed-a-bug-in-handling-of-stream-timeouts.patch
Patch0010: CVE-2023-45802-improved-early-cleanup-of-streams.patch
Patch0011: CVE-2023-38709-header-validation-after-content.patch
Patch0012: CVE-2024-24795-let-httpd-handle-CL-TE-for-non-http-handlers.patch
Patch0013: CVE-2024-27316-bail-after-too-many-failed-reads.patch
Patch0014: CVE-2024-38473-mod_proxy-escape-for-non-proxypass-configuration.patch
Patch0015: CVE-2024-38473-mod_proxy-Fixup-UDS-filename.patch
Patch0016: CVE-2024-38473-CVE-2024-39573-block-inadvertent-subst-of-special-filename.patch
Patch0017: CVE-2024-38473-fix-comparsion-of-local-path.patch
Patch0018: CVE-2024-38473-fix-the-filename-redirected.patch
Patch0019: CVE-2024-38474-CVE-2024-38475-tighten-up-prefix_stat.patch
Patch0020: CVE-2024-38476-add-ap_set_content_type_ex-to-differentiate-trusted-sources.patch
Patch0021: CVE-2024-38477-validate-hostsname.patch

Patch3000: httpd-2.4.43-apxs.patch
Patch3001: httpd-2.4.43-deplibs.patch
Patch3002: httpd-2.4.53-detect-systemd.patch
Patch3003: httpd-2.4.43-mod_systemd.patch
Patch3004: httpd-2.4.53-export.patch
Patch3005: httpd-2.4.43-corelimit.patch
Patch3006: httpd-2.4.54-selinux.patch
Patch3007: httpd-2.4.54-icons.patch
Patch3008: httpd-2.4.43-cachehardmax.patch
Patch3009: httpd-2.4.43-socket-activation.patch
Patch3010: httpd-2.4.43-sslciphdefault.patch
Patch3011: httpd-2.4.43-sslprotdefault.patch
Patch3012: httpd-2.4.48-r1828172+.patch
Patch3013: httpd-2.4.43-logjournal.patch
Patch3014: httpd-2.4.46-htcacheclean-dont-break.patch

BuildRequires: gcc autoconf pkgconfig findutils xmlto gnupg2 systemd-rpm-macros
BuildRequires: apr-devel apr-util-devel pcre2-devel libuuid-devel systemd-devel
BuildRequires: zlib-devel libselinux-devel lua-devel brotli-devel

Requires: httpd-core = %{version}-%{release} system-logos-httpd
Provides: webserver
Recommends: mod_http2 mod_lua
%{?systemd_requires}

%description
The Apache HTTP Server Project is an effort to develop and
maintain an open-source HTTP server for modern operating
systems including UNIX and Windows. The goal of this project
is to provide a secure, efficient and extensible server that
provides HTTP services in sync with the current HTTP standards.

%package core
Summary: httpd minimal core
Requires: /etc/mime.types
Requires: httpd-tools = %{version}-%{release}
Requires: httpd-filesystem = %{version}-%{release}
Requires(pre): httpd-filesystem
Provides: mod_dav = %{version}-%{release}, httpd-suexec = %{version}-%{release}
Provides: httpd-mmn = %{mmn}, httpd-mmn = %{mmnisa}
Provides: mod_proxy_uwsgi = %{version}-%{release}

%description core
The  package provides essential httpd binaries.

%package devel
Summary: Development interfaces for the Apache HTTP Server
Requires: apr-devel, apr-util-devel, pkgconfig, libtool
Requires: httpd-core = %{version}-%{release}

%description devel
This package provides the APXS binary and other files that you need
to build Dynamic Shared Objects (DSOs) for the Apache HTTP Server.

If you are installing the Apache HTTP Server and you want to be
able to compile or develop additional modules for Apache, you need
to install this package.

%package filesystem
Summary: The basic directory layout for the Apache HTTP Server
BuildArch: noarch
%{?sysusers_requires_compat}

%description filesystem
This package provides the basic directory layout for the
Apache HTTP Server including the correct permissions for the directories.

%package tools
Summary: Tools for use with the Apache HTTP Server

%description tools
This package provides tools which can be used with the Apache HTTP Server.

%package -n mod_ssl
Summary: SSL/TLS module for the Apache HTTP Server
BuildRequires: openssl-devel
Requires(pre): httpd-filesystem
Requires: httpd-core = %{version}-%{release}, httpd-mmn = %{mmnisa}
Requires: /usr/bin/hostname

%description -n mod_ssl
This packages provides strong cryptography for the Apache HTTP
server via the Secure Sockets Layer (SSL) and Transport Layer
Security (TLS) protocols.

%package -n mod_proxy_html
Summary: HTML and XML content filters for the Apache HTTP Server
Requires: httpd-core = %{version}-%{release}, httpd-mmn = %{mmnisa}
BuildRequires: libxml2-devel
BuildRequires: make

%description -n mod_proxy_html
This package provides filters which can transform and modify HTML and XML content.

%package -n mod_ldap
Summary: LDAP authentication modules for the Apache HTTP Server
Requires: httpd-core = %{version}-%{release}, httpd-mmn = %{mmnisa}
Requires: apr-util-ldap

%description -n mod_ldap
This package add support for LDAP authentication to the Apache HTTP Server.

%package -n mod_session
Summary: Session interface for the Apache HTTP Server
Requires: httpd-core = %{version}-%{release}, httpd-mmn = %{mmnisa}

%description -n mod_session
This package provides an abstract interface for storing and accessing per-user session data.

%package -n mod_lua
Summary: Lua scripting support for the Apache HTTP Server
Requires: httpd-core = %{version}-%{release}, httpd-mmn = %{mmnisa}

%description -n mod_lua
This package allows the server to be extended with scripts written
in the Lua programming language.

%prep
%setup -q
%autopatch -p1 -m 3000 -M 3002
%patch0001 -p1
%autopatch -p1 -m 3003 -M 3006
%patch0002 -p1
%autopatch -p1 -m 3007 -M 3011
%autopatch -p1 -m 3012 -M 3013
%autopatch -p1 -m 0005 -M 0007
%patch3014 -p1

sed -i '/^#define PLATFORM/s/Unix/%{vstring}/' os/unix/os.h
sed -i '/suexec/s/setcap /echo Skipping setcap for /' Makefile.in

cp -p %{_sourcedir}/instance.conf .
sed < %{_sourcedir}/httpd.conf >> instance.conf '
0,/^ServerRoot/d;
/# Supplemental configuration/,$d
/^ *CustomLog .logs/s,logs/,logs/${HTTPD_INSTANCE}_,
/^ *ErrorLog .logs/s,logs/,logs/${HTTPD_INSTANCE}_,
'

vmmn=`echo MODULE_MAGIC_NUMBER_MAJOR | cpp -include include/ap_mmn.h | sed -n '/^2/p'`
if test "x${vmmn}" != "x%{mmn}"; then
   echo "Error: Upstream MMN is now ${vmmn}, packaged MMN is %{mmn}"
   exit 1
fi

cp %{_sourcedir}/apache-poweredby.png ./docs/icons/apache_pb3.png
cp %{_sourcedir}/config.layout .
sed -i 's/OpenCloudOS/%{_vendor}/g' config.layout

%build
rm -rf srclib/{apr,apr-util,pcre}

autoheader && autoconf || exit 1

export LYNX_PATH=/usr/bin/links

./configure \
        --prefix=%{_sysconfdir}/httpd \
        --exec-prefix=%{_prefix} \
        --bindir=%{_bindir} \
        --sbindir=%{_sbindir} \
        --mandir=%{_mandir} \
        --libdir=%{_libdir} \
        --sysconfdir=%{_sysconfdir}/httpd/conf \
        --includedir=%{_includedir}/httpd \
        --libexecdir=%{_libdir}/httpd/modules \
        --datadir=%{httpddir} \
        --enable-layout=%{_vendor} \
        --with-installbuilddir=%{_libdir}/httpd/build \
        --enable-mpms-shared=all \
        --with-apr=%{_prefix} --with-apr-util=%{_prefix} \
        --enable-suexec --with-suexec \
        --enable-suexec-capabilities \
        --with-suexec-caller=%{suexec_caller} \
        --with-suexec-docroot=%{docroot} \
        --without-suexec-logfile \
        --with-suexec-syslog \
        --with-suexec-bin=%{_sbindir}/suexec \
        --with-suexec-uidmin=1000 --with-suexec-gidmin=1000 \
        --with-brotli \
        --enable-pie \
        --with-pcre2=%{_bindir}/pcre2-config \
        --enable-mods-shared=all \
        --enable-ssl --with-ssl --disable-distcache \
        --enable-proxy --enable-proxy-fdpass \
        --enable-cache \
        --enable-disk-cache \
        --enable-ldap --enable-authnz-ldap \
        --enable-cgid --enable-cgi \
        --enable-cgid-fdpassing \
        --enable-authn-anon --enable-authn-alias \
        --enable-systemd \
        --disable-imagemap --disable-file-cache \
        --disable-http2 \
        --disable-md \
        $*
%make_build

%install
rm -rf %{buildroot}

%make_install
mkdir -p %{buildroot}%{_unitdir}/httpd.service.d \
         %{buildroot}%{_localstatedir}/lib/httpd \
         %{buildroot}/run/httpd/htcacheclean

install -p -m 644 %{_sourcedir}/httpd.service        %{buildroot}%{_unitdir}/httpd.service
install -p -m 644 %{_sourcedir}/htcacheclean.service %{buildroot}%{_unitdir}/htcacheclean.service
install -p -m 644 %{_sourcedir}/httpd.socket         %{buildroot}%{_unitdir}/httpd.socket
install -p -m 644 %{_sourcedir}/httpd@.service       %{buildroot}%{_unitdir}/httpd@.service
install -p -m 644 %{_sourcedir}/httpd-init.service   %{buildroot}%{_unitdir}/httpd-init.service
install -D -m 644 %{_sourcedir}/README.confd    %{buildroot}%{_sysconfdir}/httpd/conf.d/README
install -D -m 644 %{_sourcedir}/README.confmod  %{buildroot}%{_sysconfdir}/httpd/conf.modules.d/README

for f in 00-base.conf 00-mpm.conf 00-lua.conf 01-cgi.conf 00-dav.conf \
         00-proxy.conf 00-ssl.conf 01-ldap.conf 00-proxyhtml.conf \
         01-ldap.conf 00-systemd.conf 01-session.conf 00-optional.conf \
         00-brotli.conf; do
  install -m 644 -p %{_sourcedir}/$f \
        %{buildroot}%{_sysconfdir}/httpd/conf.modules.d/$f
done

sed -i '/^#LoadModule mpm_%{mpm}_module /s/^#//' \
     %{buildroot}%{_sysconfdir}/httpd/conf.modules.d/00-mpm.conf
touch -r %{_sourcedir}/00-mpm.conf \
     %{buildroot}%{_sysconfdir}/httpd/conf.modules.d/00-mpm.conf


install -D -m 644 -p %{_sourcedir}/10-listen443.conf \
      %{buildroot}%{_unitdir}/httpd.socket.d/10-listen443.conf

for f in welcome.conf ssl.conf userdir.conf; do
  install -m 644 -p %{_sourcedir}/$f \
        %{buildroot}%{_sysconfdir}/httpd/conf.d/$f
done

install -m 644 docs/conf/extra/httpd-autoindex.conf \
      %{buildroot}%{_sysconfdir}/httpd/conf.d/autoindex.conf

rm -v docs/conf/extra/httpd-{ssl,userdir}.conf
rm %{buildroot}%{_sysconfdir}/httpd/conf/*.conf
install -m 644 -p %{_sourcedir}/httpd.conf \
   %{buildroot}%{_sysconfdir}/httpd/conf/httpd.conf

install -D -m 644 -p %{_sourcedir}/htcacheclean.sysconf \
   %{buildroot}%{_sysconfdir}/sysconfig/htcacheclean

install -D -m 644 -p %{_sourcedir}/httpd.tmpfiles \
   %{buildroot}%{_prefix}/lib/tmpfiles.d/httpd.conf

sed -i '/^DavLockDB/d'                                             docs/conf/extra/*.conf
sed -i 's,@@ServerRoot@@/user.passwd,/etc/httpd/conf/user.passwd,' docs/conf/extra/*.conf
sed -i 's,@@ServerRoot@@/docs,%{docroot},'                         docs/conf/extra/*.conf
sed -i 's,@@ServerRoot@@,%{docroot},'                              docs/conf/extra/*.conf
sed -i 's,@@Port@@,80,'                                            docs/conf/extra/*.conf

mkdir -p %{buildroot}%{_localstatedir}/cache/httpd \
         %{buildroot}%{_localstatedir}/cache/httpd/proxy \
         %{buildroot}%{_localstatedir}/cache/httpd/ssl

echo %{mmnisa} > %{buildroot}%{_includedir}/httpd/.mmn
mkdir -p %{buildroot}%{_rpmconfigdir}/macros.d
cat > %{buildroot}%{_rpmconfigdir}/macros.d/macros.httpd <<EOF
%%_httpd_mmn %{mmnisa}
%%_httpd_apxs %%{_libdir}/httpd/build/vendor-apxs
%%_httpd_modconfdir %%{_sysconfdir}/httpd/conf.modules.d
%%_httpd_confdir %%{_sysconfdir}/httpd/conf.d
%%_httpd_contentdir %{httpddir}
%%_httpd_moddir %%{_libdir}/httpd/modules
%%_httpd_requires Requires: httpd-mmn = %%{_httpd_mmn}
EOF

mkdir %{buildroot}%{httpddir}/noindex \
      %{buildroot}%{httpddir}/server-status
ln -s ../../testpage/index.html \
      %{buildroot}%{httpddir}/noindex/index.html
install -m 644 -p docs/server-status/* \
        %{buildroot}%{httpddir}/server-status
rm -rf %{httpddir}/htdocs

# do not support html manual
rm -rf %{buildroot}%{httpddir}/manual

rm -v %{buildroot}%{docroot}/html/*.html \
      %{buildroot}%{docroot}/cgi-bin/*

ln -s ../../pixmaps/poweredby.png \
        %{buildroot}%{httpddir}/icons/poweredby.png

ln -s ../../pixmaps/system-noindex-logo.png \
        %{buildroot}%{httpddir}/icons/system_noindex_logo.png

rmdir %{buildroot}/etc/httpd/{state,run}
ln -s ../..%{_localstatedir}/log/httpd %{buildroot}/etc/httpd/logs
ln -s ../..%{_localstatedir}/lib/httpd %{buildroot}/etc/httpd/state
ln -s /run/httpd %{buildroot}/etc/httpd/run
ln -s ../..%{_libdir}/httpd/modules %{buildroot}/etc/httpd/modules

install -D -m755 %{_sourcedir}/httpd-ssl-pass-dialog \
        %{buildroot}%{_libexecdir}/httpd-ssl-pass-dialog

# install http-ssl-gencerts
install -m755 %{_sourcedir}/httpd-ssl-gencerts \
        %{buildroot}%{_libexecdir}/httpd-ssl-gencerts


install -D -m 644 -p %{_sourcedir}/httpd.logrotate \
        %{buildroot}/etc/logrotate.d/httpd

sed -i '/.*DEFAULT_..._LIBEXECDIR/d;/DEFAULT_..._INSTALLBUILDDIR/d' \
    %{buildroot}%{_includedir}/httpd/ap_config_layout.h

sed -i '/instdso/s,top_srcdir,top_builddir,' \
    %{buildroot}%{_libdir}/httpd/build/special.mk

cp -p %{buildroot}%{_libdir}/httpd/build/config_vars.mk \
      %{buildroot}%{_libdir}/httpd/build/vendor_config_vars.mk

sed -e '/^CFLAGS/s,=.*$,= -O2 -g -Wall,' \
    -e '/^LIBTOOL/s,/.*/libtool,%{_bindir}/libtool,' \
    -i %{buildroot}%{_libdir}/httpd/build/config_vars.mk
diff -u %{buildroot}%{_libdir}/httpd/build/vendor_config_vars.mk \
     %{buildroot}%{_libdir}/httpd/build/config_vars.mk || true

sed 's/config_vars.mk/vendor_config_vars.mk/' \
    %{buildroot}%{_bindir}/apxs \
    > %{buildroot}%{_libdir}/httpd/build/vendor-apxs
touch -r %{buildroot}%{_bindir}/apxs \
      %{buildroot}%{_libdir}/httpd/build/vendor-apxs
chmod 755 %{buildroot}%{_libdir}/httpd/build/vendor-apxs

install -p -D -m 0644 %{_sourcedir}/httpd.sysusers %{buildroot}%{_sysusersdir}/httpd.conf

rm -vf \
      %{buildroot}/etc/httpd/conf/mime.types \
      %{buildroot}%{_libdir}/httpd/modules/*.exp \
      %{buildroot}%{_libdir}/httpd/build/config.nice \
      %{buildroot}%{_sbindir}/{checkgid,envvars*} \

rm -rf %{buildroot}/etc/httpd/conf/{original,extra}

%pre filesystem
%sysusers_create_compat %{_sourcedir}/httpd.sysusers

%post
%systemd_post httpd.service htcacheclean.service httpd.socket

%preun
%systemd_preun httpd.service htcacheclean.service httpd.socket

%postun
%systemd_postun httpd.service htcacheclean.service httpd.socket

%posttrans
test -f /etc/sysconfig/httpd-disable-posttrans || \
  /bin/systemctl try-restart --no-block httpd.service htcacheclean.service >/dev/null 2>&1 || :

%check
make -C server exports.o
nm --defined httpd > exports-actual.list
set +x
rv=0
nm --defined-only server/exports.o | \
  sed -n '/ap_hack_/{s/.* ap_hack_//;/^ap[ru]/d;p;}' | \
  while read sym; do
    if ! grep -q " "$sym\$ exports-actual.list; then
     echo ERROR: Symbol $sym missing in httpd exports
     rv=1
    fi
  done
if [ $rv -eq 0 ]; then
  echo PASS: Symbol export list verified.
fi

if readelf -d %{buildroot}%{_libdir}/httpd/modules/*.so | grep TEXTREL; then
   echo FAIL: Modules contain non-relocatable code
   rv=1
else
   echo PASS: No non-relocatable code in module builds
fi

for f in %{buildroot}%{_libdir}/httpd/modules/*.so; do
  m=${f##*/}
  if ! grep -q $m %{buildroot}%{_sysconfdir}/httpd/conf.modules.d/*.conf; then
    echo FAIL: Module $m not configured.  Disable it, or load it.
    rv=1
   else
    echo PASS: Module $m is configured and loaded.
  fi
done

mods=`grep -h ^LoadModule %{buildroot}%{_sysconfdir}/httpd/conf.modules.d/*.conf | sed 's,.*modules/,,'`
for m in $mods; do
  f=%{buildroot}%{_libdir}/httpd/modules/${m}
  if ! test -x $f; then
    echo FAIL: Module $m is configured but not built.
    rv=1
  else
    echo PASS: Loaded module $m is installed.
  fi
done
set -x
exit $rv

%files
%config(noreplace) %{_sysconfdir}/httpd/conf.modules.d/00-brotli.conf
%config(noreplace) %{_sysconfdir}/httpd/conf.modules.d/00-systemd.conf
%{_libdir}/httpd/modules/mod_brotli.so
%{_libdir}/httpd/modules/mod_systemd.so
%{_unitdir}/httpd.service
%{_unitdir}/httpd@.service
%{_unitdir}/htcacheclean.service
%{_unitdir}/*.socket
%{_mandir}/man8/*

%files core
%license ABOUT_APACHE LICENSE
%doc README CHANGES VERSIONING NOTICE
%doc docs/conf/extra/*.conf
%doc instance.conf
%{_sysconfdir}/httpd/modules
%{_sysconfdir}/httpd/logs
%{_sysconfdir}/httpd/state
%{_sysconfdir}/httpd/run
%{_sysconfdir}/httpd/conf.modules.d/README
%dir %{_sysconfdir}/httpd/conf
%dir %{_sysconfdir}/httpd/conf.modules.d

%config(noreplace) %{_sysconfdir}/httpd/conf/httpd.conf
%config(noreplace) %{_sysconfdir}/httpd/conf/magic
%config(noreplace) %{_sysconfdir}/logrotate.d/httpd
%config(noreplace) %{_sysconfdir}/httpd/conf.d/*.conf
%exclude %{_sysconfdir}/httpd/conf.d/ssl.conf
%exclude %{_sysconfdir}/httpd/conf.d/manual.conf

%config(noreplace) %{_sysconfdir}/httpd/conf.modules.d/*.conf
%exclude %{_sysconfdir}/httpd/conf.modules.d/00-brotli.conf
%exclude %{_sysconfdir}/httpd/conf.modules.d/00-systemd.conf
%exclude %{_sysconfdir}/httpd/conf.modules.d/00-ssl.conf
%exclude %{_sysconfdir}/httpd/conf.modules.d/00-proxyhtml.conf
%exclude %{_sysconfdir}/httpd/conf.modules.d/00-lua.conf
%exclude %{_sysconfdir}/httpd/conf.modules.d/01-ldap.conf
%exclude %{_sysconfdir}/httpd/conf.modules.d/01-session.conf
%config(noreplace) %{_sysconfdir}/sysconfig/htcacheclean
%{_prefix}/lib/tmpfiles.d/httpd.conf
%{_sbindir}/ht*
%{_sbindir}/fcgistarter
%{_sbindir}/apachectl
%{_sbindir}/rotatelogs
%caps(cap_setuid,cap_setgid+pe) %attr(510,root,%{suexec_caller}) %{_sbindir}/suexec

%dir %{_libdir}/httpd
%dir %{_libdir}/httpd/modules
%{_libdir}/httpd/modules/mod*.so
%exclude %{_libdir}/httpd/modules/mod_brotli.so
%exclude %{_libdir}/httpd/modules/mod_systemd.so
%exclude %{_libdir}/httpd/modules/mod_auth_form.so
%exclude %{_libdir}/httpd/modules/mod_ssl.so
%exclude %{_libdir}/httpd/modules/mod_*ldap.so
%exclude %{_libdir}/httpd/modules/mod_proxy_html.so
%exclude %{_libdir}/httpd/modules/mod_xml2enc.so
%exclude %{_libdir}/httpd/modules/mod_session*.so
%exclude %{_libdir}/httpd/modules/mod_lua.so

%dir %{httpddir}/error
%dir %{httpddir}/error/include
%dir %{httpddir}/noindex
%dir %{httpddir}/server-status
%{httpddir}/icons/*
%{httpddir}/error/README
%{httpddir}/error/*.var
%{httpddir}/error/include/*.html
%{httpddir}/noindex/index.html
%{httpddir}/server-status/*

%attr(0710,root,apache) %dir /run/httpd
%attr(0700,apache,apache) %dir /run/httpd/htcacheclean
%attr(0700,root,root) %dir %{_localstatedir}/log/httpd
%attr(0700,apache,apache) %dir %{_localstatedir}/lib/httpd
%attr(0700,apache,apache) %dir %{_localstatedir}/cache/httpd
%attr(0700,apache,apache) %dir %{_localstatedir}/cache/httpd/proxy


%files filesystem
%dir %{_sysconfdir}/httpd
%dir %{_sysconfdir}/httpd/conf.d
%{_sysconfdir}/httpd/conf.d/README
%dir %{docroot}
%dir %{docroot}/cgi-bin
%dir %{docroot}/html
%dir %{httpddir}
%dir %{httpddir}/icons
%attr(755,root,root) %dir %{_unitdir}/httpd.service.d
%attr(755,root,root) %dir %{_unitdir}/httpd.socket.d
%{_sysusersdir}/httpd.conf

%files tools
%{_bindir}/*
%license LICENSE
%doc NOTICE
%{_mandir}/man1/*
%exclude %{_bindir}/apxs
%exclude %{_mandir}/man1/apxs.1*

%files -n mod_ssl
%{_libdir}/httpd/modules/mod_ssl.so
%config(noreplace) %{_sysconfdir}/httpd/conf.modules.d/00-ssl.conf
%config(noreplace) %{_sysconfdir}/httpd/conf.d/ssl.conf
%attr(0700,apache,root) %dir %{_localstatedir}/cache/httpd/ssl
%{_unitdir}/httpd-init.service
%{_libexecdir}/httpd-ssl-pass-dialog
%{_libexecdir}/httpd-ssl-gencerts
%{_unitdir}/httpd.socket.d/10-listen443.conf

%files -n mod_proxy_html
%config(noreplace) %{_sysconfdir}/httpd/conf.modules.d/00-proxyhtml.conf
%{_libdir}/httpd/modules/mod_proxy_html.so
%{_libdir}/httpd/modules/mod_xml2enc.so

%files -n mod_ldap
%config(noreplace) %{_sysconfdir}/httpd/conf.modules.d/01-ldap.conf
%{_libdir}/httpd/modules/mod_*ldap.so

%files -n mod_session
%config(noreplace) %{_sysconfdir}/httpd/conf.modules.d/01-session.conf
%{_libdir}/httpd/modules/mod_session*.so
%{_libdir}/httpd/modules/mod_auth_form.so

%files -n mod_lua
%config(noreplace) %{_sysconfdir}/httpd/conf.modules.d/00-lua.conf
%{_libdir}/httpd/modules/mod_lua.so

%files devel
%{_includedir}/httpd
%{_bindir}/apxs
%dir %{_libdir}/httpd/build
%{_libdir}/httpd/build/*.mk
%{_libdir}/httpd/build/*.sh
%{_libdir}/httpd/build/vendor-apxs
%{_rpmconfigdir}/macros.d/macros.httpd
%{_mandir}/man1/apxs.1*

%changelog
* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.4.57-9
- Rebuilt for loongarch release

* Thu Jul 25 2024 wynnfeng <wynnfeng@tencent.com> - 2.4.57-8
- [type] security
- [desc] fix CVE-2024-38473, 2024-38474, CVE-2024-38475, CVE-2024-38476, CVE-2024-38477, CVE-2024-39573

* Fri Apr 26 2024 wynnfeng <wynnfeng@tencent.com> - 2.4.57-7
- [type] security
- [desc] fix CVE-2023-38709, CVE-2024-27316, CVE-2024-24795

* Fri Apr 26 2024 wynnfeng <wynnfeng@tencent.com> - 2.4.57-6
- [type] bugfix
- [desc] add httpd-ssl-gencerts becuase httpd-init.service needs

* Wed Mar 6 2024 wynnfeng <wynnfeng@tencent.com> - 2.4.57-5
- add require system-logos-httpd to offer testpage/index.html

* Fri Nov 10 2023 wynnfeng <wynnfeng@tencent.com> - 2.4.57-4
- fix CVE-2023-31122 and CVE-2023-45802 and CVE-2023-43622

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.4.57-3
- Rebuilt for OpenCloudOS Stream 23.09

* Thu Aug 17 2023 kianli@tencent.com - 2.4.57-2
- Rebuilt for apr 1.7.4 and apr-util 1.6.3

* Mon Jul 17 2023 cunshunxia <cunshunxia@tencent.com> - 2.4.57-1
- upgrade to 2.4.57

* Mon Jul 03 2023 Xin Cheng <denisecheng@tencent.com> - 2.4.54-5
- sed all "OpenCloudOS" with %_vender in config.layout

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.4.54-4
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.4.54-3
- Rebuilt for OpenCloudOS Stream 23

* Tue Nov 15 2022 Shuo Wang <abushwang@tencent.com> - 2.4.54-2
- fix for httpd start fail

* Wed Sep 14 2022 Shuo Wang <abushwang@tencent.com> - 2.4.54-1
- initial build

